/// <reference types="node" />
import cp from 'child_process';
export interface ServerProperties {
    serverName: string;
    gamemode: "survival" | "creative";
    forceGamemode: boolean;
    difficulty: "peaceful" | "easy" | "normal" | "hard";
    allowCheats: boolean;
    maxPlayers: number;
    onlineMode: boolean;
    allowList: boolean;
    serverPort: number;
    serverPortv6: number;
    viewDistance: number;
    tickDistance: number;
    playerIdleTimeout: number;
    maxThreads: number;
    levelName: string;
    levelSeed: string;
    defaultPlayerPermissionLevel: "visitor" | "member" | "operator";
    texturepackRequired: boolean;
    contentLogFileEnabled: boolean;
    compressionThreshold: number;
    serverAuthoritativeMovement: "client-auth" | "server-auth" | "server-auth-with-rewind";
    playerMovementScoreThreshold: number;
    playerMovementActionDirectionThreshold: number;
    playerMovementDistanceThreshold: number;
    playerMovementDurationThresholdInMs: number;
    correctPlayerMovement: boolean;
    serverAuthoritativeBlockBreaking: boolean;
    emitServerTelemetry: boolean;
}
declare class BedrockServer {
    readonly folder: string;
    proc: cp.ChildProcess;
    static server_properties_default: ServerProperties;
    static server_properties_data: string;
    static getLatestDownloadURL(url?: string): Promise<string>;
    static camelcaseToDashCase(str: string): string;
    static createServerProperitesData(serverProperties?: ServerProperties): string;
    constructor(folder: string);
    initServerFolder(zipurl: string, properties?: ServerProperties, files?: {
        [key: string]: string | Buffer;
    }): Promise<void>;
    initServerFolder(zipdata: Buffer, properties?: ServerProperties, files?: {
        [key: string]: string | Buffer;
    }): void;
    changeServerProperties(properties: ServerProperties): void;
    start(): cp.ChildProcess;
    stop(code?: NodeJS.Signals): number;
}
export default BedrockServer;
