import BedrockServer from '.';
import fs from 'fs';

async function download() {
    const url = await BedrockServer.getLatestDownloadURL();

    console.log(url);

    const server = new BedrockServer('./test-server');

    await server.initServerFolder(url);

    const proc = server.start();

    proc.stdout.pipe(process.stdout);
    proc.stderr.pipe(process.stderr);
    process.openStdin().pipe(proc.stdin);
}

async function read() {
    const fdata = await fs.promises.readFile('./bedrock-server-1.19.1.01.zip');

    const server = new BedrockServer('./test-server');

    server.initServerFolder(fdata);

    const proc = server.start();

    proc.stdout.pipe(process.stdout);
    proc.stderr.pipe(process.stderr);
    process.openStdin().pipe(proc.stdin);
}

read();
download;